module DIFF_PLS(CLK,RST,DIN,DOUT);

input  CLK, RST;
input  DIN;
output DOUT;
reg    DOUT;

reg STATE;
parameter S0 = 1'b0;
parameter S1 = 1'b1;

always @( posedge CLK or posedge RST ) begin
	if ( RST ) begin
		DOUT <= 0;
	end
	else begin
		case( STATE )
			S0 : 
			 	begin
					if( DIN==1 ) begin
						DOUT  <= 1;
						STATE <= S1;
					end
					else begin						
						STATE <= S0;
					end
				end
			S1 :
				begin
					if( DIN==0 ) begin
						DOUT  <= 0;
						STATE <= S0;
					end
					else begin
						DOUT  <= 0;
						STATE <= S1;
					end
				end
			default : STATE <= S0;
		endcase
	end
end

endmodule
