module REPLY( CLK, RST, BUSY, READY, HUR, MIN, RE, DIN, WE, DOUT );

input  CLK, RST, RE;
input  READY;
output BUSY;
output WE;
input  [7:0] DIN;
output [7:0] DOUT;
reg    [7:0] DOUT;

input  [7:0] HUR;
input  [7:0] MIN;
reg       BUSY;
reg       WE;
reg [2:0] STATE;
parameter S0 = 3'b000;
parameter S1 = 3'b001;
parameter S2 = 3'b010;
parameter S3 = 3'b011;
parameter S4 = 3'b100;

parameter AST = 8'h2A;

/***                      */
/**  READ STATE MACHINE  **/
/*                      ***/
always @( posedge CLK or posedge RST ) begin
	if ( RST ) begin
		BUSY <= 1'b0;
		DOUT <= 8'b0;
		WE <= 1'b0;
		STATE <= S0;
	end
	else begin
		case( STATE )
			S0 : 
			 	begin
					if( RE==1'b1 && DIN==AST ) begin
						BUSY  <= 1'b1;
						STATE <= S1;
					end
					else
						STATE <= S0;
				end
			S1 :
				begin
					if( READY==1'b1 ) begin
						WE    <= 1'b1;
						DOUT  <= HUR;
						STATE <= S2;
					end
					else
						STATE <= S1;
				end
			S2 :
				begin
					STATE <= S3;
				end
			S3 : 
				begin
					if( READY==1'b1 ) begin
						WE    <= 1'b1;
						DOUT  <= MIN;
						STATE <= S4;
					end
					else begin
					   WE    <= 1'b0;
						STATE <= S3;
					end
				end
			S4 :
				begin
					WE    <= 1'b0;
					BUSY  <= 1'b0;
					STATE <= S0;
				end
			default : STATE <= S0;
		endcase
	end
end

endmodule
