/***           */
/**  SEG_DEC  **/
/*           ***/
module SEG_DEC( D_IN, D_OUT );
    input    [3:0] D_IN;
    output   [6:0] D_OUT;

	 function [6:0] DEC;
	 input [3:0] D_IN;
	 case ( D_IN )
	 	4'h0: DEC = 7'b1000000; // 0
		4'h1: DEC = 7'b1111001; // 1
		4'h2: DEC = 7'b0100100; // 2
		4'h3: DEC = 7'b0110000; // 3
		4'h4: DEC = 7'b0011001; // 4
		4'h5: DEC = 7'b0010010; // 5
		4'h6: DEC = 7'b0000010; // 6
		4'h7: DEC = 7'b1111000; // 7
		4'h8: DEC = 7'b0000000; // 8
		4'h9: DEC = 7'b0010000; // 9
		4'ha: DEC = 7'b0001000; // a
		4'hb: DEC = 7'b0000011; // b
		4'hc: DEC = 7'b1000110; // c
		4'hd: DEC = 7'b0100001; // d
		4'he: DEC = 7'b0000110; // e
		4'hf: DEC = 7'b0001110; // f
		default : DEC = 7'bxxxxxxx;
   endcase
	endfunction

	assign D_OUT = DEC( D_IN );

endmodule

