/***           */
/**  SEG_MUX  **/
/*           ***/
module SEG_MUX( DATA_A, DATA_B, DATA_C, DATA_D, DATA_OUT, SEL, SA);

input  [6:0] DATA_A, DATA_B, DATA_C, DATA_D;
input  [1:0] SEL;
output [6:0] DATA_OUT;
output [3:0] SA;

function [3:0] DEC_SA;
	input [1:0] SEL;

	case ( SEL )
		2'h0: DEC_SA = 4'b0zzz; 
		2'h1: DEC_SA = 4'bz0zz;
		2'h2: DEC_SA = 4'bzz0z; 
		2'h3: DEC_SA = 4'bzzz0; 
		default : DEC_SA   = 4'bzzzz;
	endcase
endfunction

function [6:0] DEC_DATA;	 
	input [6:0] DATA_A, DATA_B, DATA_C, DATA_D;
	input [1:0] SEL;

	case ( SEL )
		2'h0: DEC_DATA = DATA_A; 
		2'h1: DEC_DATA = DATA_B;
		2'h2: DEC_DATA = DATA_C;
		2'h3: DEC_DATA = DATA_D;
		default : DEC_DATA = 7'bxxxxxxx;
	endcase
endfunction

assign DATA_OUT = DEC_DATA( DATA_A, DATA_B, DATA_C, DATA_D, SEL );	
assign SA       = DEC_SA( SEL );

endmodule
